﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Documents.Word;
using System.Windows.Media.Imaging;
using System.Windows.Resources;
using System.IO;
using Infragistics.Imaging;

namespace ExportImageToWord
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        MemoryStream documentStream;

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            documentStream = new MemoryStream();
            WordDocumentWriter docWriter = WordDocumentWriter.Create(documentStream);
            docWriter.ImageEncoder = new JpegImageEncoder();
            docWriter.StartDocument();
            docWriter.StartParagraph();
            docWriter.AddInlinePicture(LoadImage(@"/ExportImageToWord;component/dog.jpg"));
            docWriter.AddNewLine();
            docWriter.EndParagraph();
            docWriter.EndDocument();
            docWriter.Close();
            OpenDocument();          

        }

        private void OpenDocument()
        {
            SaveFileDialog dialog = new SaveFileDialog { Filter = "Word files|*.docx", DefaultExt = "docx" };
            bool? showDialog = dialog.ShowDialog();
            if (showDialog == true)
            {
                using (Stream exportStream = dialog.OpenFile())
                {
                    byte[] data = documentStream.ToArray();
                    exportStream.Write(data, 0, data.Length);
                    exportStream.Close();
                }
            }
        }


        public BitmapImage LoadImage(string relativeUriString)
        {
            Uri uri = new Uri(relativeUriString, UriKind.Relative);
            StreamResourceInfo sri = Application.GetResourceStream(uri);

            BitmapImage bi = new BitmapImage();
            bi.SetSource(sri.Stream);
            Image img = new Image();
            img.Source = bi;

            return bi;
        }
    }
}
